<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class Food_Online_Shortcode {

	protected static $_instance = null;

	protected $is_active = false;

	public function __construct() {

		add_shortcode( 'foodonline', array( $this, 'shortcode' ) );



	}

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}

		return self::$_instance;
	}

public function shortcode( $atts ) {

		if ( $this->is_active && get_option('fdoe_force_shortcode','no')=='no') {
			return;
		}

		//Fix for WooCommerce Product Add Ons
		if ( defined( 'WC_PRODUCT_ADDONS_VERSION' ) && version_compare( WC_PRODUCT_ADDONS_VERSION, '3.0.0', '>=' ) ) {
		      wp_register_script( 'jquery-tiptip', WC()->plugin_url() . '/assets/js/jquery-tiptip/jquery.tipTip' . '.min' . '.js', array( 'jquery' ), WC_VERSION, true );
			  wp_enqueue_script( 'jquery-tiptip' );

			   wp_register_style( 'woocommerce-addons-css', plugins_url() . '/woocommerce-product-addons/assets/css/frontend.css', array( 'dashicons' ), WC_PRODUCT_ADDONS_VERSION );
			  wp_enqueue_style( 'woocommerce-addons-css' );
		}

		$this->is_active = true;

		$options = shortcode_atts( array(
			'categories'         => null,
			'tags'               => null,


		), $atts );






	$args =	array(

    'status'               => 'publish',
    'limit'                => -1,
  //  'page'                 => $paged,
    'paginate'             => true,
    'return'               => 'ids',
    'orderby'              => 'name',
    'order'                => 'ASC',
  );
		$args['product_tag'] = trim( $options['tags'] );
		$args['product_cat'] = trim( $options['categories'] );

		ob_start();



if(!function_exists('wc_get_products')) {
    return;
  }
  $shortcode_products  = wc_get_products($args);



  if($shortcode_products) {
	// Setup the loop.

    do_action('woocommerce_before_shop_loop');
    woocommerce_product_loop_start();
      foreach($shortcode_products->products as $shortcode_product) {
        $post_object = get_post($shortcode_product);
        setup_postdata($GLOBALS['post'] =& $post_object);
        //wc_get_template_part('content', 'product');
		Food_Online::instance()->loop->the_product();
      }
	    woocommerce_product_loop_end();

      wp_reset_postdata();

    //do_action('woocommerce_after_shop_loop');
  } else {
    do_action('woocommerce_no_products_found');
  }
		$content = ob_get_clean();




		return ($content);
	}



}
